// DisableTaskbarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DisableTaskbar.h"
#include "DisableTaskbarDlg.h"
#include "Tlhelp32.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CDisableTaskbarDlg dialog

CDisableTaskbarDlg::CDisableTaskbarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisableTaskbarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDisableTaskbarDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDisableTaskbarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDisableTaskbarDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDisableTaskbarDlg, CDialog)
	//{{AFX_MSG_MAP(CDisableTaskbarDlg)
	ON_BN_CLICKED(btn_EnableStartMenu, OnEnableStartMenu)
	ON_BN_CLICKED(btn_DisableStartMenu, OnDisableStartMenu)
	ON_BN_CLICKED(btn_StartPIE, OnStartPIE)
	ON_BN_CLICKED(btn_HideStartMenu, OnHideStartMenu)
	ON_BN_CLICKED(btn_ShowStartMenu, OnShowStartMenu)
	ON_BN_CLICKED(btn_HideTaskBar, OnHideTaskBar)
	ON_BN_CLICKED(btn_ShowTaskBar, OnShowTaskBar)
	ON_BN_CLICKED(btn_HideSIP, OnHideSIP)
	ON_BN_CLICKED(btn_ShowSIP, OnShowSIP)
	ON_BN_CLICKED(IDC_Exit, OnExit)
	ON_BN_CLICKED(IDC_LockDLG, OnLockDLG)
	ON_BN_CLICKED(IDC_UnlockDialog, OnUnlockDialog)
	ON_BN_CLICKED(btn_StartPIE2, OnStartAndWaitPIE)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisableTaskbarDlg message handlers

BOOL CDisableTaskbarDlg::OnInitDialog()
{
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	// remember the Locked Status
	m_IsLocked = false;
	// TODO: Add extra initialization here

	CDialog::OnInitDialog();

	// Call SHInitDialog with flags for full screen.
	SHINITDLGINFO shidi;

	shidi.dwMask = SHIDIM_FLAGS;
	shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR;
	shidi.hDlg = m_hWnd;
	SHInitDialog(&shidi);

	::SHDoneButton(CDisableTaskbarDlg::GetSafeHwnd(), SHDB_HIDE);

	// Set the icon for this dialog box. The framework does this automatically
	//  when the application's main window is not a dialog box.
	SetIcon(m_hIcon, TRUE);   // Set big icon.
	SetIcon(m_hIcon, FALSE);  // Set small icon.
	
   //Hide the Close X in the upper right corner 
	SHDoneButton(m_hWnd, SHDB_HIDE);
	ModifyStyle(0, WS_NONAVDONEBUTTON, SWP_NOSIZE); 

	GetDlgItem(IDC_UnlockDialog)->EnableWindow(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CDisableTaskbarDlg::OnEnableStartMenu() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWSTARTICON);
}


void CDisableTaskbarDlg::OnDisableStartMenu() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDESTARTICON);	
}

void CDisableTaskbarDlg::OnStartPIE() 
{
	// TODO: Add your control notification handler code here

	PROCESS_INFORMATION pi;
	bool PIEstarted;
	DWORD IEpid;
	HANDLE hIE, handleIE;
	UINT exitCode;
	DWORD result;
	HWND IEhWnd ;
	//Is PIE already running? Get a handle to PIE window
	IEhWnd = ::FindWindow(NULL,_T("Internet Explorer"));
	if (IEhWnd==NULL)
	{
		MessageBeep(MB_ICONEXCLAMATION);
	}
	else
	{
		MessageBox(_T("Internet Explorer is already running.\nTrying to terminate."), _T("Caution"), MB_ICONERROR | MB_OK);
		//MsgBox(NULL,_T("Internet Explorer found"), _T("SUCCESS"), mbx_flags);
	
		//Get the process ID to PIE
		result = ::GetWindowThreadProcessId(IEhWnd, &IEpid);
		
		if ( (handleIE = ::OpenProcess(0, false, IEpid)) != NULL )
		{
			exitCode=1;
			result = ::TerminateProcess(handleIE, exitCode);// Kill PIE
			if ( result = 0 )
			{
				MessageBeep(MB_ICONEXCLAMATION);
			}
			else
				MessageBeep(MB_OK);
		}
		else
			MessageBeep(MB_ICONEXCLAMATION);
	}

	//Create a new PIE
	if (::CreateProcess(L"iexplore.exe", L"", NULL, NULL, NULL,0,NULL,NULL,NULL,&pi) != 0)
	{
		hIE = pi.hThread;
		IEpid = pi.dwProcessId;
		PIEstarted = true;
	}
	else
	{
		PIEstarted = false;
		CloseHandle (pi.hThread);
		CloseHandle (pi.hProcess);
	}
	if (PIEstarted)
	{
		IEhWnd = ::FindWindow(NULL,_T("Internet Explorer"));
		result = ::GetWindowThreadProcessId(IEhWnd, &IEpid);
		hIE = ::OpenProcess(0, false, IEpid);
		//Wait about 5 Seconds
		Sleep(5000);
		hIE = ::OpenProcess(0, false, IEpid);
		//Close PIE
		exitCode=0;
		result = TerminateProcess(hIE, exitCode);// Kill PIE
		if (result=0)
			MessageBox(_T("TerminateProcess -Internet Explorer- failed"), _T("Error"), MB_ICONERROR | MB_OK);
		::CloseHandle (pi.hThread);
		::CloseHandle (pi.hProcess);
	}
	if (m_IsLocked)
		SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDESTARTICON | SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON);
	else
		SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWSTARTICON | SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON);
}


void CDisableTaskbarDlg::OnHideStartMenu() 
{
	// TODO: Add your control notification handler code here
	//BOOL SHFullScreen (HWND hwndRequester, DWORD dwState);
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDESTARTICON);
}

void CDisableTaskbarDlg::OnShowStartMenu() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWSTARTICON);
	
}

void CDisableTaskbarDlg::OnHideTaskBar() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDETASKBAR);
}

void CDisableTaskbarDlg::OnShowTaskBar() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWTASKBAR);
}

void CDisableTaskbarDlg::OnHideSIP() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDESIPBUTTON);	
}

void CDisableTaskbarDlg::OnShowSIP() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWSIPBUTTON);
}

void CDisableTaskbarDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	CDisableTaskbarDlg::PostMessage (WM_QUIT,0,0);
}

void CDisableTaskbarDlg::OnLockDLG() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDESTARTICON | SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON);
	CDisableTaskbarDlg::m_IsLocked = true;
	GetDlgItem(IDC_UnlockDialog)->EnableWindow(TRUE);
	GetDlgItem(IDC_LockDLG)->EnableWindow(FALSE);
}

void CDisableTaskbarDlg::OnUnlockDialog() 
{
	// TODO: Add your control notification handler code here
	SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWSTARTICON | SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON);
	CDisableTaskbarDlg::m_IsLocked = false;
	GetDlgItem(IDC_LockDLG)->EnableWindow(TRUE);
	GetDlgItem(IDC_UnlockDialog)->EnableWindow(FALSE);
	
}

void CDisableTaskbarDlg::OnStartAndWaitPIE() 
{
	// TODO: Add your control notification handler code here
	PROCESS_INFORMATION pi;
//	bool PIEstarted;
	DWORD IEpid;
	HANDLE handleIE;
	UINT exitCode;
	DWORD result;
	HWND IEhWnd ;
	//Is PIE already running? Get a handle to PIE window
	IEhWnd = ::FindWindow(NULL,_T("Internet Explorer"));
	if (IEhWnd==NULL)
	{
		MessageBeep(MB_ICONEXCLAMATION);
	}
	else
	{
		MessageBox(_T("Internet Explorer is already running.\nTrying to terminate."), _T("Caution"), MB_ICONERROR | MB_OK);
		//MsgBox(NULL,_T("Internet Explorer found"), _T("SUCCESS"), mbx_flags);
	
		//Get the process ID to PIE
		result = ::GetWindowThreadProcessId(IEhWnd, &IEpid);
		
		if ( (handleIE = ::OpenProcess(0, false, IEpid)) != NULL )
		{
			exitCode=1;
			result = ::TerminateProcess(handleIE, exitCode);// Kill PIE
			if ( result = 0 )
			{
				MessageBeep(MB_ICONEXCLAMATION);
			}
			else
				MessageBeep(MB_OK);
		}
		else
			MessageBeep(MB_ICONEXCLAMATION);
	}

	//Create a new PIE
	if(CreateProcess(_T("\\windows\\iexplore.exe"), NULL, NULL, NULL, FALSE, 0,
				NULL, NULL, NULL, &pi) == 0)
		MessageBox(_T("Could not create process \\windows\\iexplore.exe!"), L"ERROR", MB_OK | MB_TOPMOST);
	else
	{
		if(WaitForSingleObject(pi.hProcess, INFINITE) == WAIT_FAILED)
			MessageBox(_T("Could not wait on object: \\windows\\iexplore.exe!"), L"ERROR", MB_OK | MB_TOPMOST);
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
	}
//===========
    
	if (m_IsLocked)
		SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_HIDESTARTICON | SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON);
	else
		SHFullScreen(CDisableTaskbarDlg::GetSafeHwnd(), SHFS_SHOWSTARTICON | SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON);
	
}
